var CMCE = {
// services
pref: Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefService).getBranch("compact.menu."),

overlayFunction: function(oldFunc, oldCodeList, newCodeList) {
	try {
		let func = eval(oldFunc).toString();
		for (let i in oldCodeList)
			if (func.indexOf(oldCodeList[i]) < 0) {
				Components.utils.reportError('"' + oldCodeList[i] + '" not found in function ' + '"' + oldFunc + '"');
				return false;
			}

		for (let i in oldCodeList)
			func = func.replace(oldCodeList[i], newCodeList[i]);

		eval(oldFunc + "=" + func);
		return true;
	} catch(e) {
		return false;
	}
},

getItemListFromPref: function(pref) {
	return CMCE.pref.getComplexValue(pref, Components.interfaces.nsISupportsString).data;
},

setIdsInMenubar: function(menubar) {
	for (var menu=menubar.firstChild; menu; menu=menu.nextSibling)
		try {
			if (menu.tagName == "menu") {
				if (!menu.id)
					menu.id = menubar.id + "-" + escape(menu.getAttribute("label"));
				if (menu.lastChild)
					this.setItemIDs(menu.lastChild);
			}
		} catch(e) {
			Components.utils.reportError('Failed accessing childnode in "' + menubar.id + '":' + e);
		}
},

setItemIDs: function(container) {
	for (var item=container.firstChild; item; item=item.nextSibling)
		try {
			if (item.tagName == "menu" &&
					(this.isPureContainer(item) || item.id == "viewFullZoomMenu") &&
					this.isPureContainer(item.lastChild)
			) {
				this.setItemIDs(item.lastChild);
			} else {
				var label = item.getAttribute("label");
				if (!item.id && label) item.id = container.parentNode.id + "-" + escape(label);
			}
		} catch(e) {
			Components.utils.reportError('Failed accessing childnode in "' + container.id + '":' + e);
		}
},

isPureContainer: function(item) {
	if (
		item &&
		!item.getAttribute("onpopupshowing") &&
		!item.getAttribute("onpopupshown") &&
		!item.getAttribute("onpopuphiding") &&
		!item.getAttribute("onpopuphidden") &&
		!item.getAttribute("oncommand")
	) return true;
	else return false;
},

init: function() {
// add ids for menu items in menu bar before doing anything about the menus.
	this.setIdsInMenubar(document.getElementById("main-menubar"));
	document.documentElement.setAttribute("selectedSkin", gPrefService.getCharPref("general.skins.selectedSkin"));

// check if first run or update
	var currentVersion = "6.0.0";
	var lastVersion = this.pref.getCharPref("lastVersion");

	if (lastVersion != currentVersion) {
		if(!document.getElementById("appmenu-button")) {
			setTimeout(function() {
				// pop a confirm for asking whether add the buttons
				if (Services.prompt.confirm(null, "Personal Menu", document.getElementById("compact-addbutton").label)) {
					var toolbar = document.getElementById("nav-bar");
					toolbar.collapsed = false;
					toolbar.insertItem("appmenu-button");
					toolbar.setAttribute("currentset", toolbar.currentSet);
					document.persist("nav-bar","currentset");
				}
			}, 0);
		}

		if(!lastVersion) {
		} else {
			// clear old prefs after update
			var prefs = [
				"setButtonsB", "setButtonsH", "error", "HMC", // since 3.0
				"defaultitemlist", "delay", "firstrun", "hidemenu", "hidemenubar", "oldStyle", // since 4.0
				"bookmarkMiddleClickOpens", "bookmarkRightClickOpens", // since 4.1pre
				"menuPosition-menu", "menuPosition-bookmarks", "menuPosition-history", // since 4.1
				"warning", // since 4.2.0
				"toolbarCollapsed", // since 4.3.2
				"itemlist", "showlist", "hidelist", "popupmenu", "menuMiddleClickOpens",
				"buttonStyle", "hideBorderTop", "BookmarksButton-menu", "position-menu", // since 5.0
				"compactGoMenu", // since 5.0.6
				"compactHistoryMenu", "compactBookmarksMenu", "maxCount", "noarrow", "enableHotkey", "bookmarksMiddleClickOpens",
				"bookmarksRightClickOpens", "hidepopup", "historyMiddleClickOpens", "historyRightClickOpens",
				"altToggle", "position-bookmarks", "position-history", // since 6.0.0
			];
			for (var i in prefs)
				try { this.pref.clearUserPref(prefs[i]) } catch(e) {}
		}

		this.pref.setCharPref("lastVersion", currentVersion);
	}

	// workaround with Menu Editor
	this.overlayFunction(
		"MenuEdit.editMenu",
		["if (!MenuEditRDF.getVisibility(node)"],
		['if (!MenuEditRDF.getVisibility(node) && p.id=="contentAreaContextMenu"']
	);

	// placesmenu ondragenter fix
	this.overlayFunction(
		"PlacesMenuDNDHandler._isStaticContainer",
		['node.localName == "toolbarbutton"'],
		['(node.localName == "toolbarbutton" || node.localName == "button")']
	);
},

initAppMenu: function() {
	let appmenu = document.getElementById("appmenu-popup");

	let containers = appmenu.cm_containers = [
		document.getElementById("appmenuPrimaryPane"),
		document.getElementById("appmenuSecondaryPane")
	];

	for (let i in containers) {
		containers[i].cm_topMenu = appmenu;
		for (let item = containers[i].firstChild; item; item = item.nextSibling)
			item.setAttribute("cm-visibility", "hide");

		let endMarker = containers[i].cm_endMarker =
				containers[i].insertBefore(document.createElement("menuseparator"), containers[i].firstChild);
		let startMarker = containers[i].cm_startMarker =
				containers[i].insertBefore(document.createElement("menuseparator"), containers[i].firstChild);
		startMarker.className = "cm-startMarker";
		endMarker.className = "cm-endMarker";
		startMarker.hidden = true;
		endMarker.hidden = true;
	}

	appmenu.addEventListener("popupshowing", CMCE.onOpenMenu, false);
	appmenu.addEventListener("popuphidden", CMCE.onCloseMenu, false);

	appmenu.setAttribute("cm-menu", true);

	this.updateMenuList();
},

middleClickHandler: function(event) {
	if (event.button == 1 && event.eventPhase != 2) {
		setTimeout(function(target) {
			if(!target.open || target.cm_prefs && target.cm_prefs.closeAfterMidClick) {
				closeMenus(target);
			}
		}, 2, event.currentTarget);
	}
},

updateMenuList: function() {
	var hasBookmarksItem = false;
	var appmenu = document.getElementById("appmenu-popup").parentNode;

	for (var i = 0; i < 2; i++) {
		var list = CMCE.getItemListFromPref(["primaryList", "secondaryList"][i]);
		document.getElementById(["appmenuPrimaryPane", "appmenuSecondaryPane"][i]).cm_list =
				list.split(",");
		if (list.indexOf("cm-bookmarks-box") > -1)
			hasBookmarksItem = true;
	}

	if(hasBookmarksItem && !appmenu.lastChild.hasAttribute("placespopup")) {
		appmenu.addEventListener("dragenter", function(event){PlacesMenuDNDHandler.onDragEnter(event)}, true);
		appmenu.lastChild.setAttribute("placespopup", true);
	}
},

onOpenMenu: function(event) {
	if (event.eventPhase != 2) return;
	var menu = event.currentTarget;
	for(var i in menu.cm_containers) {
		var container = menu.cm_containers[i];

		if (!menu.cm_initialized) {
			var hasItems = CMCE.initializeMenu(container, container.cm_list, false);

			container.hidden = !hasItems && i > 0;
		}
		CMCE.createMenu(container, true);
	}
	menu.cm_initialized = true;

	//a workaround for bug of firefox...
	try{
		let scrollbox = document.getAnonymousElementByAttribute(menu, "class", "popup-internal-box")._scrollbox;
		if(scrollbox.clientHeight >= menu.firstChild.scrollHeight) {
			scrollbox.style.overflowY = "hidden";
			scrollbox.width = ""
		} else {
			scrollbox.style.overflowY = "";
			scrollbox.width = scrollbox.boxObject.width + scrollbox.scrollWidth - scrollbox.clientWidth;
		}
	} catch(e) {
		Components.utils.reportError('appmenu has an unexpected binding: ' + e);
	}
},

/**
 * @return is any item show in menu
 */
initializeMenu: function(container, itemIDs, canBeEmpty) {
	var topMenu = container;
	var initializingToolbar = false;
	var uniqueIdCount = 0;
	var toolbarPalette = document.getElementById("navigator-toolbox").palette;
	var editMenuItem = document.getElementById("compact-extra-prefs");

	for (var i = 0; i<itemIDs.length; i++) {
		try {
			if (itemIDs[i] == "----") {
				if (initializingToolbar)
					container.insertBefore(document.createElement("toolbarseparator"), container.cm_endMarker);
				else {
					var item = container.insertBefore(document.createElement("menuseparator"), container.cm_endMarker);
					if(container == topMenu)
						item.className = "appmenu-menuseparator";
				}
			} else if (itemIDs[i] == "cm-submenu") {
				container = container.insertBefore(document.getElementById(itemIDs[i]).cloneNode(true), container.cm_endMarker);
				container.id += uniqueIdCount++;
				container.setAttribute("label", itemIDs[++i]);
				if (itemIDs[++i] != "empty") container.setAttribute("accesskey", itemIDs[i]);
				container = container.firstChild;
			} else if (itemIDs[i] == "cm-splitmenu-end") {
				if (!container.hasChildNodes()) container.appendChild(editMenuItem.cloneNode(true)).id = "";
				container = container.parentNode.parentNode.parentNode;
			} else if (itemIDs[i] == "cm-submenu-end" || itemIDs[i] == "cm-buttons-box-end") {
				if (!container.hasChildNodes()) container.appendChild(editMenuItem.cloneNode(true)).id = "";
				container = container.parentNode.parentNode;
				initializingToolbar = false;
			} else if (itemIDs[i] == "cm-spring") {
				if (initializingToolbar)
					container.appendChild(document.createElement("toolbarspring")).setAttribute("flex", 1);
				else
					container.insertBefore(document.createElement("spacer"), container.cm_endMarker).setAttribute("flex", 1);
			} else if (itemIDs[i] == "cm-spacer") {
				if (initializingToolbar)
					container.appendChild(document.createElement("toolbarspacer"));
				else
					container.insertBefore(document.createElement("spacer"), container.cm_endMarker).setAttribute("style", "min-height: 1em;");
			} else if (initializingToolbar) {
				for (var item = toolbarPalette.firstChild; item && item.id != itemIDs[i]; item = item.nextSibling);
				if (item) {
					container.appendChild(item.cloneNode(true)).setAttribute("cui-areatype", "toolbar");
					switch(item.id) {
						case "personal-bookmarks":
							new PlacesToolbar("place:folder=TOOLBAR");
							break;
						case "abp-toolbarbutton":
							break;
					}
				}
			} else if (itemIDs[i] == "cm-buttons-box") {
				container = container.insertBefore(document.getElementById(itemIDs[i]).cloneNode(true), container.cm_endMarker);
				container.id += uniqueIdCount++;
				container = container.firstChild;
				for (var j=0; j<3; j++) container.setAttribute(["adv", "iconsize", "mode"][j], itemIDs[++i]);
				initializingToolbar = true;
			} else {
				var isSplitmenu = itemIDs[i] == "cm-splitmenu";
				var dummy = null;

				if(isSplitmenu) i++;

				var item = document.getElementById(itemIDs[i]);
				if (item && !item.cm_buttonPrefs) {
					dummy = item.cloneNode(false);
					if(item.lastChild && item.lastChild.tagName == "menupopup")
						dummy.appendChild(document.createElement("menupopup"));
					dummy.disabled = true;
					dummy.id = "cmRestorePoint-" + itemIDs[i];
					dummy.cm_target = item;
					if (item.parentNode.cm_list || item.parentNode.cm_list == "")
						dummy.hidden = true;

					//create an object to save some settings
					item.cm_prefs = {};

					 // these menuitems need to be updated their status when their original menu shows
					var identity = item.getAttribute("command") || item.id;
					 switch (identity) {
						//personal menu items
						case "cm-history-box":
							if(!item._placesView) {
								new HistoryMenu({target:item.lastChild, originalTarget:item.lastChild});
							}
							item.cm_updateCmd = function() {
								this._placesView._rebuildPopup(this.lastChild);
								if (this.lastChild._endSeparator)
									this.lastChild._endSeparator.className = "appmenu-menuseparator";
							};
							item.cm_prefs.dontRestore = true;
							break;
						case "cm-bookmarks-box":
							if(!item._placesView) {
								item.lastChild.addEventListener("DOMNodeInserted", function(event) {
									if(event.target.tagName == "menuseparator" && event.target.parentNode == this)
										event.target.className = "appmenu-menuseparator";
								}, false);
								new PlacesMenu({target:item.lastChild, originalTarget:item.lastChild},
										"place:folder=BOOKMARKS_MENU");
								item.controllers.removeControllerAt(0);
							}
							if(!item.controllers.getControllerCount())
								setTimeout(function(item){
									item.controllers.appendController(item._placesView._controller);
								}, 0, item);

							item.cm_prefs.dontRestore = true;
							break;

						//history menu items
					 	case "historyUndoMenu":
						case "appmenu_recentlyClosedTabsMenu":
							if(!item.parentNode.parentNode._placesView)
								new HistoryMenu({target:item.parentNode, originalTarget:item.parentNode});
					 		item.cm_updateCmd = function() {
								this.parentNode.parentNode._placesView.toggleRecentlyClosedTabs();
								this.parentNode.parentNode._placesView.populateUndoSubmenu();
							}
							item.cm_prefs.needRestore = true;
							item.cm_prefs.closeAfterMidClick = true;
					 		break;
					 	case "historyUndoWindowMenu":
						case "appmenu_recentlyClosedWindowsMenu":
							if(!item.parentNode.parentNode._placesView)
								new HistoryMenu({target:item.parentNode, originalTarget:item.parentNode});
					 		item.cm_updateCmd = function() {
								this.parentNode.parentNode._placesView.toggleRecentlyClosedWindows();
								this.parentNode.parentNode._placesView.populateUndoWindowSubmenu();
							}
							item.cm_prefs.needRestore = true;
					 		break;
						case "historyRestoreLastSession":
						case "appmenu_restoreLastSession":
							if(!item.parentNode.parentNode._placesView)
								new HistoryMenu({target:item.parentNode, originalTarget:item.parentNode});
					 		item.cm_updateCmd = function() {
					 			this.parentNode.parentNode._placesView.toggleRestoreLastSession();
					 		}
							item.cm_prefs.needRestore = true;
					 		break;
						case "sync-tabs-menuitem":
					 		item.cm_updateCmd = HistoryMenu.prototype.toggleTabsFromOtherComputers;
					 		break;

						//bookmarks menu items
						case "bookmarksToolbarFolderMenu":
//						case "appmenu_bookmarksToolbar":
						case "unfiledBookmarksFolderMenu":
							if(identity == "unfiledBookmarksFolderMenu")
								item.setAttribute("label",
										PlacesUtils.bookmarks.getItemTitle(PlacesUtils.bookmarks.unfiledBookmarksFolder));

							if(!item.cm_eventAdded) {
								item.addEventListener("command", function(event) {
									if (this.parentNode.id != "bookmarksMenuPopup"
											&& this.parentNode.id != "appmenu_bookmarksPopup")
									{
										BookmarksEventHandler.onCommand(event);
									}
								}, true);
								item.addEventListener("click", function(event) {
									if (this.parentNode.id != "bookmarksMenuPopup"
											&& this.parentNode.id != "appmenu_bookmarksPopup")
									{
										BookmarksEventHandler.onClick(event);
									}
								}, true);
								item.cm_eventAdded = true;
							}
							item.cm_prefs.dontRestore = true;
							break;
						case "Browser:ShowAllBookmarks":
							item.cm_prefs.dontRestore = true;
							break;

						//view menu items
						case "cmd_fullZoomToggle":
							item.cm_updateCmd = FullZoom.updateMenu;
							break;

						//help menu items
						case "menu_HelpPopup_reportPhishingtoolmenu":
						case "menu_HelpPopup_reportPhishingErrortoolmenu":
							item.cm_updateCmd = buildHelpMenu;
							break;

						//appmenu items
						case "cmd_ToggleTabsOnTop":
							item.cm_updateCmd = function() {
								this.setAttribute("checked", TabsOnTop.enabled);
							};
							break;

						default:
							//history submenus
							if(identity.indexOf("hsub") == 0 && "historySubmenus" in window) {
								if(!item.cm_eventAdded) {
									item.addEventListener("click", function(event){
										event.stopPropagation();
										if(event.originalTarget._placesNode)
											openUILinkIn(event.originalTarget._placesNode.uri,
													gBrowser.currentURI.spec == "about:blank" && !gBrowser.mIsBusy ? "current" : "tab");
									}, false);
									item.cm_eventAdded = true;
								}

								item.cm_updateCmd = historySubmenus.verifySubmenus;
							}
							break;
					}
				}

				if(isSplitmenu) {
					container = container.insertBefore(document.getElementById("cm-splitmenu").cloneNode(true),
							container.cm_endMarker);
					container.id += uniqueIdCount++;
					if(dummy)
						container.replaceChild(dummy, container.firstChild);
					container =  container.lastChild.firstChild;
				} else if(dummy)
					container.insertBefore(dummy, container.cm_endMarker);
			}
		} catch(e) {
			Components.utils.reportError('Failed initializing "' + itemIDs[i] + '":' + e);
		}
	}

	if (!canBeEmpty && (!container.firstChild ||
			!container.cm_startMarker && !container.cm_endMarker.previousSibling ||
			!container.cm_endMarker && !container.cm_startMarker.nextSibling ||
			container.cm_startMarker.nextSibling == container.cm_endMarker)) {
		container.insertBefore(editMenuItem.cloneNode(true), container.cm_endMarker).id = "";
		return false;
	}

	return true;
},

getStartPoint: function(container) {
	let cursor = 0;

	if (container.cm_startMarker)
		for (let item = container.childNodes[0];
				cursor < container.childNodes.length && container.childNodes[cursor] != container.cm_startMarker;
				cursor++);

	return cursor;
},

createMenu: function(container, isTopMenu) {
	for (let cursor = this.getStartPoint(container); container.childNodes[cursor] != container.cm_endMarker; cursor++) {
		let item = container.childNodes[cursor];

		 if (item.id.indexOf("cm-submenu") > -1) {
		 	this.createMenu(item.firstChild, false);
		 } else if (item.id.indexOf("cm-splitmenu") > -1) {
			this.handleItem(item.firstChild, isTopMenu);
			this.createMenu(item.lastChild.firstChild, false);
		} else if (item.cm_target || item.cm_prefs) {
			this.handleItem(item, isTopMenu);
		}
	}
},

handleItem: function(requestItem, isTopMenu) {
	if(requestItem.cm_prefs && requestItem.cm_prefs.restorePoint) {
		if(requestItem.cm_updateCmd)
			try {
				requestItem.cm_updateCmd();
			} catch(e) {
				Components.utils.reportError('Failed updating "' + requestItem.id + '":' + e);
			}
	} else if(requestItem.cm_target) {
		let dummy = requestItem;
		let item = requestItem.cm_target;

		if(item.cm_updateCmd)
			try {
				item.cm_updateCmd();
			} catch(e) {
				Components.utils.reportError('Failed updating "' + item.id + '":' + e);
			}

		let itemPosition = dummy.nextSibling;
		let itemContainer = dummy.parentNode;

		if (item.parentNode.cm_list)
			item.removeAttribute("cm-visibility");

		item.parentNode.replaceChild(dummy, item);
		itemContainer.insertBefore(item, itemPosition);


		item.cm_prefs.restorePoint = dummy;
		item.cm_prefs.originalClassName = item.className;
		item.cm_prefs.originalTooltipText = item.tooltipText || "";
		item.cm_prefs.originalAccessKey = item.accessKey || "";
		item.removeAttribute("accesskey");

		if (item.tagName == "menu" || item.tagName == "splitmenu") {
			item.addEventListener("click", CMCE.middleClickHandler, true);
		} else if (isTopMenu) {
			if (item.tagName == "menuitem") {
				item.classList.add("menuitem-iconic-tooltip");
				item.classList.add("menuitem-iconic");
			}
		}

		if (itemContainer.id.indexOf("cm-splitmenu") > -1) {
			item.cm_prefs.originalFlex = item.flex;
			item.flex = 1;
			item.className = "splitmenu-menuitem";
		}
	}
},

onCloseMenu: function(event) {
	if (event.eventPhase != 2) return;

	var restoreAll = CMCE.pref.getBoolPref("restoreAfterClosed");
	var containers = event.currentTarget.cm_containers;

	for(var i in containers)
		setTimeout(CMCE.restoreMenu, 0, containers[i], true, restoreAll, false);
},

restoreMenu: function(container, isTopMenu, restoreAll, forcedRestore) {
	if(!forcedRestore && isTopMenu && container.cm_topMenu.parentNode.open) {
		Components.utils.reportError("Trying to restore items in an open menu");
		return;
	}

	for (let cursor = CMCE.getStartPoint(container); container.childNodes[cursor] != container.cm_endMarker; cursor++) {
		let item = container.childNodes[cursor];

		if (item.id.indexOf("cm-submenu") > -1)
			CMCE.restoreMenu(item.firstChild, false, restoreAll, forcedRestore);
		else {
			if (item.id.indexOf("cm-splitmenu") > -1) {
				CMCE.restoreMenu(item.lastChild.lastChild, false, restoreAll, forcedRestore);
				item = item.firstChild;
			}

			if (item.cm_prefs
					&& item.cm_prefs.restorePoint
					&& (forcedRestore ||
							(restoreAll || item.cm_prefs.needRestore) && !item.cm_prefs.dontRestore)  )
				CMCE.restoreItem(item, item.parentNode, isTopMenu);
		}
	}
},

restoreItem:function(item, container, inTopMenu) {
	var position = item.nextSibling;
	var dummy = item.cm_prefs.restorePoint;
	dummy.parentNode.replaceChild(item, dummy);
	container.insertBefore(dummy, position);

	item.className = item.cm_prefs.originalClassName;

	if (item.parentNode.cm_list)
		item.setAttribute("cm-visibility", "hide");

	if(container.id.indexOf("cm-splitmenu") > -1)
		item.flex = item.cm_prefs.originalFlex;

	if (inTopMenu) {
		item.tooltipText = item.cm_prefs.originalTooltipText;
		item.accessKey =  item.cm_prefs.originalAccessKey;

		item.removeEventListener("click", CMCE.middleClickHandler, true);
	}
},
}