var Setting = {
inIDOMUtils: Components.classes["@mozilla.org/inspector/dom-utils;1"].getService(Components.interfaces["inIDOMUtils"]),

currentList: null,
currentAvailList: null,

updateItem: function() {
	var string = ["history-menu", "bookmarksMenu"];
	for (var i in string) {
		var treeItem = document.getElementsByAttribute("targetId", string[i]);
		var target = BrowserDoc.getElementById(string[i]);
		var isButton = target.cm_buttonPrefs && target.cm_buttonPrefs.restorePoint;

		for (var j=0; j<treeItem.length; j++) {
			if (isButton) {
				this.addProperty(treeItem[j], "disabled");
				treeItem[j].hidden = false;
			} else if (treeItem[j].isAdded) {
				if (treeItem[j].getAttribute("empty")) {
					treeItem[j].hidden = true;
					this.removeProperty(treeItem[j], "disabled");
				}
			} else
				this.removeProperty(treeItem[j], "disabled");
			treeItem[j].allwaysDisabled = isButton;
		}
	}
},

dialogOncommand: function(event){
	var parent = event.target.parentNode.parentNode;
	var a = event.target.tagName;
	if((a == "checkbox" || a == "menuitem" || a == "radio") && !event.target.hasAttribute("apply")) this.enbleApply();
},

setMinSize: function() {
	var dialog = document.documentElement;
	var contentWrapper = document.documentElement.firstChild;

	if(dialog.clientWidth < contentWrapper.scrollWidth + contentWrapper.boxObject.x * 2
			|| dialog.clientHeight < contentWrapper.scrollHeight + contentWrapper.boxObject.y * 2)
		sizeToContent();
},

cust_loadPrefsDialog: function() {
//start prepear
	setTimeout(this.setMinSize, 0);

	if (!Browser) {
		setTimeout(function(){
			alert(document.getElementById("cm-noMainWindowError").label);
			window.close();
		}, 0);
		return;
	}

	setTimeout(window.focus, 0);

	Custom.unInitOrRestoreMenus("restore");

//prepear finished
	var isLinux = navigator.platform.indexOf("Linux")  > -1;
	if(isLinux)
		document.documentElement.setAttribute("isLinux", true);

// load the tree templates
	var tree = document.getElementById("available-tree-temp").lastChild;
	var appmenuTree = tree.getElementsByClassName("appmenu")[0].lastChild;
	var menubarTree = tree.getElementsByClassName("menubar")[0].lastChild;
	this.loadItems(
		BrowserDoc.getElementById("appmenuPrimaryPane"),
		appmenuTree,
		appmenuTree.lastChild);
	this.loadItems(
		BrowserDoc.getElementById("appmenuSecondaryPane"),
		appmenuTree);
	this.loadMenuBar(
		BrowserDoc.getElementById("main-menubar"),
		tree.getElementsByClassName("menubar")[0].lastChild
	);

	this.loadItems(BrowserDoc.getElementById("navigator-toolbox").palette,
		document.getElementById("avail-toolbar-tree-temp").lastChild);

// load the settings
	this.loadSettings();

// set buttons
	var button_box = document.getElementById("button-box");
	button_box.addButton = document.getElementById("add-button");
	button_box.removeButton = document.getElementById("remove-button");
	button_box.upButton = document.getElementById("up-button");
	button_box.downButton = document.getElementById("down-button");
	button_box.outButton = document.getElementById("out-button");
	button_box.inButton = document.getElementById("in-button");
	button_box.renameButton = document.getElementById("rename-button");
	button_box.customizeButton = document.getElementById("customize-button");
	button_box.splitButton = document.getElementById("split-button");
},

concreteAvailableItemList: function(oldTreeId, templateId) {
	var clone = document.getElementById(templateId).cloneNode(true);
	var tree = document.getElementById(oldTreeId);
	clone.id = oldTreeId;
	tree.parentNode.replaceChild(clone, tree);
	clone.addEventListener("DOMAttrModified", Setting.onToggleOpen, false);
	return clone;
},

loadMenuBar: function(menubar, tree, listEnd) {
	for (var i=0; i<menubar.childNodes.length; i++) {
		var menu = menubar.childNodes[i];

		if (menu.cm_menuTarget)
			menu = menu.cm_menuTarget;
		else if (menu.tagName != "menu")
			continue;

		this.loadMenu(menu, tree, listEnd);
	}
},

loadMenu: function(menu, tree, listEnd) {
	var treeItem = document.getElementById("folder-temp").cloneNode(true);
	var isNotAvail = false;

	treeItem.removeAttribute("id");
	if (menu.id) treeItem.setAttribute("targetId", menu.id);
	else {
		this.addProperty(treeItem, "disabled");
		isNotAvail = true;
	}

	treeItem.firstChild.firstChild.setAttribute("label", menu.getAttribute("label") ||  "( " + menu.id + " )");
	tree.insertBefore(treeItem, listEnd);

	if (menu.lastChild && menu.lastChild.tagName == "menupopup")
		this.loadItems(menu.lastChild, treeItem.lastChild);

	if (menu.tagName == "splitmenu")
		this.addProperty(treeItem, "splitmenu");

	if (!treeItem.lastChild.hasChildNodes())
		if (isNotAvail) tree.removeChild(treeItem);
		else if(menu.tagName == "splitmenu") {
			treeItem.removeAttribute("container");
			this.removeProperty(treeItem, "splitmenu");
		} else treeItem.setAttribute("empty", true);
},

loadItems: function(container, tree, listEnd) {
	let skipItem = false;
	for (var item=container.firstChild; item; item=item.nextSibling) {
		if (skipItem) {
			if (item == container.cm_endMarker)
				skipItem = false;
			continue;
		}

		if (item == container.cm_startMarker) {
			skipItem = true;
			continue;
		}

		try {
			if (
				item.tagName =="splitmenu" || item.tagName == "menu"
					&& (CMCE.isPureContainer(item) || item.id == "viewFullZoomMenu")
					&& CMCE.isPureContainer(item.firstChild)
					&& !item._placesNode
					&& item.id.indexOf("hsub") != 0
			) {
				this.loadMenu(item, tree, listEnd);
				continue;
			}
			if (
				// check for incompatible items
				!item.id
				|| item._placesNode
				|| item.tagName == "menuseparator"
				|| container.id == "menu_EditPopup" && (
					item.id == "menu_undo"
					|| item.id == "menu_redo"
					|| item.id == "menu_cut"
					|| item.id == "menu_copy"
					|| item.id == "menu_paste"
					|| item.id == "menu_delete"
					|| item.id == "textfieldDirection-swap")
				|| container.tagName == "toolbarpalette" && (
					item.className  == "cm-button"
					|| item.id == "ScrapBookEditTitle"
					|| item.id == "search-container"
					|| item.id == "urlbar-container")
				|| container.id == "appmenu_customizeMenu" &&
					item.getAttribute("toolbarId")
				|| item.tagName == "spacer"
				|| item.id == "unsortedBookmarksFolderMenuButton"
				|| item.id.indexOf(",") > -1
				|| item.id == "splitbrowser-syncScroll"
			) continue;

			var treeItem = document.getElementById("item-temp").cloneNode(true);
			treeItem.removeAttribute("id");
			treeItem.setAttribute("targetId", item.id);
			this.setLabel(item, treeItem);
			if (item.tagName == "menu") {
				treeItem.setAttribute("container", true);
				treeItem.setAttribute("empty", true);
			} else if(item.tagName == "menuitem")
				treeItem.setAttribute("cansplit", true);

			tree.insertBefore(treeItem, listEnd);
		} catch(e) {}
	}
},

setSubmenu: function(menu){
	var label = {value: menu.firstChild.firstChild.getAttribute("label")};

	do Browser.Services.prompt.prompt(
			window, "Personal Menu",
			document.getElementById("cm-labelPrompt").label,
			label,
			null,
			{value: false});
	while (label.value == "");
	if (label.value) menu.firstChild.firstChild.setAttribute("label", label.value);

	var key = {value: menu.getAttribute("accesskey")};
	if(key.value == "empty") key.value = "";
	Browser.Services.prompt.prompt(
			window, "Personal Menu",
			document.getElementById("cm-accesskeyPrompt").label,
			key,
			null,
			{value: false});
	if (key.value || key.value == "") {
		menu.setAttribute("accesskey", key.value || "empty");
		return true;
	}
	else return label.value ? true : false;
},

onToggleOpen: function(event){
	if (event.attrName == "open")
		if (event.prevValue == "true")
			for (var item=event.target.lastChild.firstChild; item; item=item.nextSibling)
				item.removeAttribute("open");
		else if (event.target.getAttribute("empty") == "true") event.target.removeAttribute("open");
},

updateButtonStatus: function() {
	setTimeout( function() {
		var  button_box = document.getElementById("button-box");
		var select = null;
		var currentAvailList = Setting.currentAvailList;
		var currentList = Setting.currentList;

		if (currentAvailList && currentAvailList.view) {
			select = currentAvailList.view.selection.count == 0 ? null : currentAvailList.view.getItemAtIndex(currentAvailList.currentIndex);

			button_box.addButton.disabled = !select
				|| Setting.hasProperty(select, "disabled")
				|| Setting.hasProperty(select, "separator")
				|| Setting.hasProperty(select, "plainContainer");
		}

		if (currentList && currentList.view) {
			select = currentList.view.selection.count == 0 ? null : currentList.view.getItemAtIndex(currentList.currentIndex);

			button_box.removeButton.disabled = !select || !select.nextSibling;
			button_box.upButton.disabled = !select || !select.previousSibling;
			button_box.downButton.disabled = !select || !select.nextSibling || select.nextSibling.hidden;
			button_box.outButton.disabled = !select
				|| select.parentNode.parentNode.getAttribute("targetId") != "cm-submenu"
					&& !Setting.hasProperty(select.parentNode.parentNode, "splitmenu")
				|| !select.nextSibling;
			button_box.inButton.disabled = !select || !select.nextSibling
				|| select.nextSibling.getAttribute("targetId") != "cm-submenu"
					&& !Setting.hasProperty(select.nextSibling, "splitmenu");
			button_box.splitButton.disabled = !select || select.getAttribute("container") && !Setting.hasProperty(select, "splitmenu")
				|| Setting.hasProperty(select, "separator") || !select.getAttribute("cansplit");
			button_box.splitButton.checked = select && Setting.hasProperty(select, "splitmenu");

			var deckIndex = 0;
			if(select)
				if(select.getAttribute("targetId") == "cm-submenu") deckIndex = 1;
				else if(select.getAttribute("targetId") == "cm-buttons-box") deckIndex = 2;
			button_box.splitButton.parentNode.selectedIndex = deckIndex;
		}
	}, 0);
},

addItem: function(){
	var currentList = this.currentList;
	var currentAvailList = this.currentAvailList;
	var fromSelect = !currentAvailList || currentAvailList.view.selection.count == 0 ?
			null : currentAvailList.view.getItemAtIndex(currentAvailList.currentIndex);
	var toSelect = !currentList || currentList.view.selection.count == 0 ?
			null : currentList.view.getItemAtIndex(currentList.currentIndex);

	if (!fromSelect
			|| this.hasProperty(fromSelect,"separator")
			|| this.hasProperty(fromSelect,"disabled")
			|| this.hasProperty(fromSelect, "plainContainer"))
		return;

	var targetId = fromSelect.getAttribute("targetId");

	if (targetId == "----") {
		var clone = document.getElementById("separator-temp").cloneNode(true);
		clone.removeAttribute("id");
	} else if (targetId == "cm-submenu") {
		var clone = document.getElementById("submenu-temp").cloneNode(true);
		if (!this.setSubmenu(clone)) return;

		clone.removeAttribute("id");
		clone.setAttribute("open", true);
		var menuend = document.getElementById("submenu-end-temp").cloneNode(true);
		menuend.removeAttribute("id");
		clone.lastChild.appendChild(menuend);
	} else if (targetId == "cm-buttons-box") {
		var clone = document.getElementById("buttonbox-temp").cloneNode(true);
		clone.removeAttribute("id");
		clone.setAttribute("open", true);
		var menuend = document.getElementById("submenu-end-temp").cloneNode(true);
		menuend.removeAttribute("id");
		menuend.setAttribute("targetId", "cm-buttons-box-end");
		clone.lastChild.appendChild(menuend);
		window.openDialog('chrome://compact-ce/content/toolbar.xul',
				'Customize Toolbar',
				'chrome,centerscreen,dialog,modal,close=no',
				clone);
	} else if (targetId == "cm-spring" || targetId == "cm-spacer") {
		var clone = document.getElementById(targetId + "-temp").cloneNode(true);
		clone.removeAttribute("id");
	} else {
		var fromSelectIndex = currentAvailList.currentIndex;
		var fromSelectIsContainer = fromSelect.getAttribute("container") && !fromSelect.getAttribute("empty");

		var clone = fromSelect.cloneNode(true);
		if (clone.childNodes.length == 2) clone.removeChild(clone.lastChild);
		clone.removeAttribute("open");

		if (fromSelectIsContainer) {
			clone.setAttribute("empty", true);
			this.addProperty(fromSelect, "disabled");
			if (this.hasProperty(fromSelect, "splitmenu")) {
				this.removeProperty(clone, "splitmenu");
				clone.removeAttribute("container");
			}
		} else
			fromSelect.hidden = true;
		fromSelect.isAdded = true;

		// set the selection of from-tree
		if (fromSelectIsContainer && fromSelectIndex < currentAvailList.view.rowCount - 1)
			currentAvailList.view.selection.select(fromSelectIndex +
				(
					currentAvailList.view.getItemAtIndex(fromSelectIndex + 1).parentNode == fromSelect.parentNode ?
						1 : -1
				)
			);
		else if (
			fromSelectIndex < currentAvailList.view.rowCount &&
			currentAvailList.view.getItemAtIndex(fromSelectIndex).parentNode == fromSelect.parentNode
		)
			currentAvailList.view.selection.select(fromSelectIndex);
		else
			currentAvailList.view.selection.select(fromSelectIndex - 1);
	}

	if (currentAvailList.currentIndex >= 0) currentAvailList.view.selection.tree.ensureRowIsVisible(currentAvailList.currentIndex);

	// append the clone, if to-select is the default item -- "edit this menu", insert before it
	if (toSelect) toSelect.parentNode.insertBefore(clone, toSelect.nextSibling || toSelect);
	else currentList.lastChild.insertBefore(clone, currentList.lastChild.lastChild);

	// if to-select is the default item, hide it
	if (clone.parentNode.childNodes.length == 2) clone.nextSibling.hidden = true;

	// select the clone, if the clone is submenu, select the default item
	currentList.view.selection.select(
		currentList.view.getIndexOfItem(
			targetId == "cm-submenu" || targetId == "cm-buttons-box" ? menuend : clone
		)
	);
	currentList.view.selection.tree.ensureRowIsVisible(currentList.currentIndex);

	Setting.setPseudo(currentList);
	Setting.setPseudo(currentAvailList);

	this.enbleApply();
},

removeItem: function(){
	var currentList = this.currentList;
	var currentAvailList = this.currentAvailList;

	var select = !currentList || currentList.view.selection.count == 0 ?
		null : currentList.view.getItemAtIndex(currentList.currentIndex);

	if (
		!select ||
		select.parentNode.childNodes.length == 1 ||
		(select.getAttribute("targetId") == "cm-submenu" || this.hasProperty(select, "splitmenu") || select.getAttribute("targetId") == "cm-buttons-box")
			&& select.lastChild.childNodes.length > 1
			&& !Browser.Services.prompt.confirm(null, "Personal Menu", document.getElementById("cm-removeSubConfirm").label)
	) return;

	var toSelectIndex = -1;
	if (select.getAttribute("targetId") == "cm-submenu") {
		this.restoreItemsInMenu(select, currentAvailList);
		toSelectIndex = 1;
	}
	else if (select.getAttribute("targetId") == "cm-buttons-box") {
		this.restoreItemsInMenu(select, document.getElementById("avail-toolbar-tree"));
		toSelectIndex = 2;
	}
	else {
		if (this.hasProperty(select, "splitmenu"))
			this.restoreItemsInMenu(select, currentAvailList);

		var same = this.restoreItem(select, currentAvailList);
		if (same) toSelectIndex = currentAvailList.view.getIndexOfItem(same);
	}

	if (toSelectIndex > -1) {
		currentAvailList.view.selection.select(toSelectIndex);
//        currentAvailList.view.selection.tree.ensureRowIsVisible(toSelectIndex);
	}

	var selectIndex = currentList.currentIndex;
	select.hidden = true;

	// show "edit this menu" if the submenu is empty after the remove
	if (select.parentNode.childNodes.length == 2) select.nextSibling.hidden = false;

	// set the selection of the tree
	if (selectIndex == 0)
		currentList.view.selection.select(0);
	else if (currentList.view.getItemAtIndex(selectIndex-1) == select.parentNode.parentNode)
		currentList.view.selection.select(selectIndex);
	else if (
		selectIndex < currentList.view.rowCount &&
		currentList.view.getItemAtIndex(selectIndex-1).parentNode != select.parentNode
	)
		currentList.view.selection.select(currentList.view.getIndexOfItem(select.previousSibling));
	else
		currentList.view.selection.select(selectIndex-1);
	currentList.view.selection.tree.ensureRowIsVisible(currentList.currentIndex);

	select.parentNode.removeChild(select);

	Setting.setPseudo(currentAvailList);
	Setting.setPseudo(currentList);

	this.enbleApply();
},

restoreItemsInMenu: function(menu, toTree) {
	for (var item=menu.lastChild.firstChild; item; item=item.nextSibling) {
		if (item.lastChild.tagName == "treechildren")
			this.restoreItemsInMenu(item, toTree);

		if(item.getAttribute("targetId") != "cm-submenu")
			this.restoreItem(item, toTree);
	}
},

restoreItem: function(item, toTree) {
	var same = toTree.getElementsByAttribute("targetId", item.getAttribute("targetId"));
	for (var i=0; i<same.length; i++) {
		same[i].isAdded = false;
		if (same[i].allwaysDisabled) continue;

		if (same[i].getAttribute("container") && !same[i].getAttribute("empty"))
			this.removeProperty(same[i], "disabled");
		else same[i].hidden = false;
	}

	return i == 0 ? null : same[i - 1];
},

moveItem: function(move) {
	var tree = this.currentList;
	var select = tree.view.selection.count == 0 ? null : tree.view.getItemAtIndex(tree.currentIndex);

	if (
		!select ||
		select.parentNode.childNodes.length == 1 ||
		move == -1 && !select.previousSibling ||
		(move == 1 || move == 2) && select.nextSibling.hidden ||
		move == -2 && select.parentNode.parentNode.getAttribute("targetId") != "cm-submenu" && !this.hasProperty(select.parentNode.parentNode, "splitmenu") ||
		move == 2 && select.nextSibling.getAttribute("targetId") != "cm-submenu" && !this.hasProperty(select.nextSibling, "splitmenu")
	) return;

	if (move == -1)
		select.parentNode.insertBefore(select, select.previousSibling);
	else if (move == 1)
		select.parentNode.insertBefore(select.nextSibling, select);
	else {
		if (move == -2) {
			if (select.parentNode.childNodes.length == 2) select.nextSibling.hidden = false;
			var parent = select.parentNode.parentNode;
			parent.parentNode.insertBefore(select, parent);
		} else {
			var parent = select.nextSibling.lastChild;
			select.nextSibling.setAttribute("open", true);
			parent.insertBefore(select, parent.firstChild);
			if (parent.childNodes.length == 2) select.nextSibling.hidden = true;
		}
	}

	tree.view.selection.select(tree.view.getIndexOfItem(select));
	tree.view.selection.tree.ensureRowIsVisible(tree.currentIndex);

	Setting.setPseudo(tree);

	this.enbleApply();
},

renameItem: function() {
	var tree = this.currentList;
	var select = tree.view.selection.count == 0 ? null : tree.view.getItemAtIndex(tree.currentIndex);

	if (select && select.getAttribute("targetId") == "cm-submenu" && this.setSubmenu(select))
		this.enbleApply();
},

customizeItem: function() {
	var tree = this.currentList;
	var select = tree.view.selection.count == 0 ? null : tree.view.getItemAtIndex(tree.currentIndex);

	if (select && select.getAttribute("targetId") == "cm-buttons-box") {
		window.openDialog(
			"chrome://compact-ce/content/toolbar.xul", null,
			"chrome,centerscreen,dialog,modal,close=no", select);
		this.enbleApply();
	}
},

toggleSplit: function() {
	var tree = this.currentList;
	var select = tree.view.selection.count == 0 ? null : tree.view.getItemAtIndex(tree.currentIndex);
	if (!select.getAttribute("cansplit")) return;

	if (select && select.getAttribute("targetId") != "cm-submenu" && select.getAttribute("targetId") != "cm-buttons-box")
		if (this.hasProperty(select, "splitmenu")) {
			if(
				select.lastChild.childNodes.length == 1
					|| Browser.Services.prompt.confirm(null, "Personal Menu", document.getElementById("cm-removeSubConfirm").label)
			) {
				var toTree = this.currentAvailList;
				this.restoreItemsInMenu(select, toTree);
				select.removeChild(select.lastChild);
				select.removeAttribute("container");
				select.removeAttribute("open");
				this.removeProperty(select, "splitmenu");

				this.enbleApply();
			}
		} else if(!select.getAttribute("container")) {
			this.changeToSplit(select);
			var split_end = document.getElementById("splitmenu-end-temp").cloneNode(true);
			split_end.removeAttribute("id");
			select.lastChild.appendChild(split_end);
			select.setAttribute("open", true);

			tree.view.selection.select(tree.view.getIndexOfItem(split_end));
			tree.view.selection.tree.ensureRowIsVisible(tree.currentIndex);

			Setting.setPseudo(tree);

			this.enbleApply();
		}
},

changeToSplit: function(item) {
	this.addProperty(item, "splitmenu");
	item.setAttribute("container", true);
	item.appendChild(document.createElement("treechildren"));
},

availTreeOndblclick: function(tree) {
	var select = tree.view.getItemAtIndex(tree.currentIndex);
	if (!select.getAttribute("container") || select.getAttribute("empty")) {
		Setting.addItem();
		select.removeAttribute("open");
	}
},

itemTreeOnselect: function(tree) {
	if(tree.isBluring) return;
	this.currentAvailList =
		tree.currentIndex == -1 ||
			tree.view.getItemAtIndex(tree.currentIndex).parentNode.parentNode.getAttribute("targetId") != "cm-buttons-box"
		?
			document.getElementById("available-tree") : document.getElementById("avail-toolbar-tree");

	if(this.currentList != tree) {
		if(this.currentList) {
			this.currentList.isBluring = true;
			this.currentList.view.selection.clearSelection();
			this.currentList.isBluring = false;
		}
		this.currentList = tree;
	}

	document.getElementById("available-tree").parentNode.parentNode.selectedIndex =
			this.currentAvailList.id =="available-tree" ? 0 : 1;
	this.updateButtonStatus();
},

loadSettings: function() {
	//reload available item lists
	this.currentAvailList = null;
	this.concreteAvailableItemList("available-tree", "available-tree-temp");
	this.concreteAvailableItemList("avail-toolbar-tree", "avail-toolbar-tree-temp");

	//reload firefox button list
	this.currentList = null;
	var primarylist = this.loadList(CMCE.getItemListFromPref("primaryList").split(","), "appmenuPrimaryPane", "available-tree", "avail-toolbar-tree");
	primarylist.view.selection.select(primarylist.view.rowCount-1);
	this.loadList(CMCE.getItemListFromPref("secondaryList").split(","), "appmenuSecondaryPane", "available-tree", "avail-toolbar-tree");
},

saveSettings: function() {
	var SSi = Components.interfaces.nsISupportsString;
	var string = Components.classes["@mozilla.org/supports-string;1"].createInstance(SSi);
	string.data = this.saveList("appmenuPrimaryPane");
	CMCE.pref.setComplexValue("primaryList", SSi, string);
	string.data = this.saveList("appmenuSecondaryPane");
	CMCE.pref.setComplexValue("secondaryList", SSi, string);

	this.applyChanges();
},

applyChanges: function() {
	Custom.unInitOrRestoreMenus("uninit");
	CMCE.updateMenuList();
},

saveList: function(listId) {
	var string = "";
	var item = document.getElementById(listId).lastChild.firstChild;

	while (item) {
		if (this.hasProperty(item, "splitmenu")) string += (string ? "," : "") + "cm-splitmenu";

		var id = item.getAttribute("targetId");
		if (id) string += (string ? "," : "") + id;
		else return string;

		if (id == "cm-submenu" || id == "cm-buttons-box") {
			if (id == "cm-submenu")
				string += "," + item.firstChild.firstChild.getAttribute("label") + "," + item.getAttribute("accesskey");
			else
				string += "," + item.getAttribute("adv") + "," + item.getAttribute("iconsize") + "," + item.getAttribute("mode");
			item = item.lastChild.firstChild;
		} else if (this.hasProperty(item, "splitmenu")) {
			item = item.lastChild.firstChild;
		} else {
			if (id == "cm-submenu-end" || id == "cm-splitmenu-end" || id == "cm-buttons-box-end")
				item = item.parentNode.parentNode;
			item = item.nextSibling;
		}
	}

	return string;
},

loadList: function(array, itemTree, availTreeId, availTBTreeId) {
	var availItmTree = document.getElementById(availTreeId).lastChild;
	var availTBItmTree = document.getElementById(availTBTreeId).lastChild;

	var availTree = availItmTree;

	var tree = document.getElementById(itemTree);
	var clone = document.getElementById("item-tree-temp").cloneNode(true);
	tree.parentNode.replaceChild(clone, tree);
	clone.id = itemTree;

	clone.addEventListener("DOMAttrModified", Setting.onToggleOpen, false);

	tree = clone.lastChild;

	for (var i=0; i<array.length; i++) {
		if (array[i] == "----") {
			var treeItem = document.getElementById("separator-temp").cloneNode(true);
			treeItem.removeAttribute("id");
			tree.appendChild(treeItem);
		} else {
			if (array[i] == "cm-submenu") {
				var treeItem = document.getElementById("submenu-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				treeItem.firstChild.firstChild.setAttribute("label",  array[++i]);
				treeItem.setAttribute("accesskey",  array[++i]);

				tree.appendChild(treeItem);
				tree = treeItem.lastChild;
			}
			else if (array[i] == "cm-submenu-end") {
				var treeItem = document.getElementById("submenu-end-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				if (tree.hasChildNodes()) treeItem.hidden = true;
				tree.appendChild(treeItem);
				tree = tree.parentNode.parentNode;
			}
			else if (array[i] == "cm-splitmenu-end") {
				var treeItem = document.getElementById("splitmenu-end-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				if (tree.hasChildNodes()) treeItem.hidden = true;
				tree.appendChild(treeItem);
				tree = tree.parentNode.parentNode;
			}
			else if (array[i] == "cm-buttons-box") {
				var treeItem = document.getElementById("buttonbox-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				treeItem.setAttribute("adv",  array[++i]);
				treeItem.setAttribute("iconsize",  array[++i]);
				treeItem.setAttribute("mode",  array[++i]);

				tree.appendChild(treeItem);
				tree = treeItem.lastChild;
				availTree = availTBItmTree;
			}
			else if (array[i] == "cm-spring" || array[i] == "cm-spacer") {
				var treeItem = document.getElementById(array[i] + "-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				tree.appendChild(treeItem);
			}
			else if (array[i] == "cm-buttons-box-end") {
				var treeItem = document.getElementById("submenu-end-temp").cloneNode(true);
				treeItem.removeAttribute("id");
				treeItem.setAttribute("targetId", "cm-buttons-box-end");
				if (tree.hasChildNodes()) treeItem.hidden = true;
				tree.appendChild(treeItem);
				tree = tree.parentNode.parentNode;
				availTree = availItmTree;
			}
			else if (!array[i]) continue;
			else {
				var splitmenu = array[i] == "cm-splitmenu";
				var treeItem = document.getElementById("item-temp").cloneNode(true);

				if (splitmenu) {
					this.changeToSplit(treeItem);
					i++;
				}

				treeItem.setAttribute("targetId",  array[i]);
				treeItem.removeAttribute("id");

				var same = availTree.getElementsByAttribute("targetId", array[i])[0];
				if (same) {
					if (same.getAttribute("container") && !same.getAttribute("empty"))
						this.addProperty(same, "disabled");
					else same.hidden = true;
					same.isAdded = true
				}
				var target = BrowserDoc.getElementById(array[i]);
				if (target) {
					this.setLabel(target, treeItem);
					if(target.tagName == "menuitem")
						treeItem.setAttribute("cansplit", true);

					if (target.tagName == "menu" && !splitmenu) {
						treeItem.setAttribute("container",  true);
						treeItem.setAttribute("empty", true);
					}
				} else if (same) {
					this.setLabel(same.firstChild.firstChild, treeItem);
				} else{
					treeItem.firstChild.firstChild.setAttribute("label", "( " + unescape(array[i]) + " )");
					this.addProperty(treeItem, "disabled");
				}
				tree.appendChild(treeItem);

				if (splitmenu) tree = treeItem.lastChild;
			}
		}
	}
	treeItem = document.getElementById("submenu-end-temp").cloneNode(true);
	treeItem.removeAttribute("id");
	treeItem.removeAttribute("targetId");
	if (tree.hasChildNodes()) treeItem.hidden = true;
	tree.appendChild(treeItem);

	return tree.parentNode;
},

setLabel: function(item, treeItem) {
	var label = "";
	if(item.id=="appmenu-edit") {
		label = item.firstChild.getAttribute("label");
	} else if(item.id=="unfiledBookmarksFolderMenu") {
		var PUb = item.ownerDocument.defaultView.PlacesUtils.bookmarks;
		item.setAttribute("label", PUb.getItemTitle(PUb.unfiledBookmarksFolder));
		label = item.getAttribute("label");
	} else if (item.id == "personal-bookmarks") {
		label = item.firstChild.firstChild.getAttribute("label");
	} else {
		label = item.getAttribute("label");
	}

	label = label || item.getAttribute("title") || "( " + item.id + " )";

	treeItem.firstChild.firstChild.setAttribute("label", label);
},

addProperty: function(treeitem, property) {
	var treecell = treeitem.firstChild.firstChild;
	var properties = treecell.getAttribute("properties");

	if(properties.indexOf(property) == -1) {
		properties += (properties ? " " : "") + property;
		treecell.setAttribute("properties", properties);
	}
},

removeProperty: function(treeitem, property) {
	var treecell = treeitem.firstChild.firstChild;
	treecell.setAttribute("properties", treecell.getAttribute("properties").replace(property, ""));
},

hasProperty: function(treeitem, property) {
	return treeitem.firstChild.firstChild.getAttribute("properties").indexOf(property) != -1;
},

enbleApply: function() {
	document.getElementById("applyButton").disabled = false;
},

setPseudo: function(el, event) {
	this.inIDOMUtils.setContentState(el, 4);
	if(event && event.type == "mousedown")
		if(el.type == "menu")
			//since onmousedown is fired before onpopupshown -- the moment that "open" is set, so need some delay
			setTimeout( function(util, el, active) {
				if(el.getAttribute("open") == "true") util.setContentState(el, 1);
			}, 10, this.inIDOMUtils, el);
		else
			this.inIDOMUtils.setContentState(el, 1);
}


}
